diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/linux.h gcc-3.0.4-eelinux/gcc/config/mips/linux.h
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/linux.h	Wed Aug  1 12:22:35 2001
+++ gcc-3.0.4-eelinux/gcc/config/mips/linux.h	Thu Mar  7 03:47:25 2002
@@ -28,6 +28,9 @@
 #undef MD_EXEC_PREFIX
 #undef MD_STARTFILE_PREFIX
 
+#undef HAVE_ATEXIT
+#define HAVE_ATEXIT
+
 /* Required to keep collect2.c happy */
 #undef OBJECT_FORMAT_COFF
 
@@ -35,6 +38,12 @@
 #undef TARGET_DEFAULT
 #define TARGET_DEFAULT (MASK_ABICALLS|MASK_GAS)
 
+#undef MACHINE_TYPE
+#if TARGET_ENDIAN_DEFAULT == 0
+#define MACHINE_TYPE "(MIPSEL Linux/ELF)"
+#else
+#define MACHINE_TYPE "(MIPS Linux/ELF)"
+#endif
 
 /* Handle #pragma weak and #pragma pack.  */
 #undef HANDLE_SYSV_PRAGMA
@@ -120,12 +129,29 @@
    the GNU/Linux magical crtbegin.o file (see crtstuff.c) which
    provides part of the support for getting C++ file-scope static
    object constructed before entering `main'. */
+/*
+ *  Notes on STARTFILE_SPEC
+ *
+ * Glibc's  __bb_* functions produce "gmon.out", on the other hand,
+ * libgcc's __bb_* functions produce "bb.out".
+ *
+ * We expect  that "gcc -a -pg" and "gcc -a -p" produce "gmon.out" and
+ * "gcc -ax" and "gcc -a" without "-p" nor "-pg" produce "bb.out".
+ *
+ *	gcc -ax		->	... -lgcc <libc> -lgcc
+ *	gcc -a -p 	-> crt_bb_wrapper.o ...-lgcc <libc> -lgcc
+ *	gcc -a -pg 	-> crt_bb_wrapper.o ...-lgcc <libc> -lgcc
+ *	gcc -a 		->	... -lgcc <libc> -lgcc
+ *
+ * <libc> will be determined in LIBC_SPEC.
+ */
 
 #undef  STARTFILE_SPEC
 #define STARTFILE_SPEC \
   "%{!shared: \
      %{pg:gcrt1.o%s} %{!pg:%{p:gcrt1.o%s} %{!p:crt1.o%s}}}\
-   crti.o%s %{!shared:crtbegin.o%s} %{shared:crtbeginS.o%s}"
+   crti.o%s %{!shared:crtbegin.o%s} %{shared:crtbeginS.o%s}\
+   %{a: %{p:crt_bb_wrapper.o%s} %{pg:crt_bb_wrapper.o%s}}"
 
 /* Provide a ENDFILE_SPEC appropriate for GNU/Linux.  Here we tack on
    the GNU/Linux magical crtend.o file (see crtstuff.c) which
@@ -169,12 +195,313 @@
 %{!fno-PIC:%{!fno-pic:-KPIC}} \
 %{fno-PIC:-non_shared} %{fno-pic:-non_shared}"
 
-/* We don't need those nonsenses.  */
+/* Support the ctors and dtors sections for g++. */
+
+/* Silence GCC when using this file for the Linux libc */
+#undef CTORS_SECTION_ASM_OP
+#undef DTORS_SECTION_ASM_OP
+#define CTORS_SECTION_ASM_OP	".section\t.ctors,\"aw\""
+#define DTORS_SECTION_ASM_OP	".section\t.dtors,\"aw\""
+
+/* A default list of other sections which we might be "in" at any given
+   time.  For targets that use additional sections (e.g. .tdesc) you
+   should override this definition in the target-specific file which
+   includes this file.  */
+
+#undef EXTRA_SECTIONS
+#define EXTRA_SECTIONS in_sdata, in_sbss, in_rdata, in_ctors, in_dtors
+
+/* A default list of extra section function definitions.  For targets
+   that use additional sections (e.g. .tdesc) you should override this
+   definition in the target-specific file which includes this file.  */
+
+#undef EXTRA_SECTION_FUNCTIONS
+#define EXTRA_SECTION_FUNCTIONS                                         \
+  SECTION_FUNCTION_TEMPLATE(sdata_section, in_sdata, SDATA_SECTION_ASM_OP) \
+  SECTION_FUNCTION_TEMPLATE(sbss_section, in_sbss, SBSS_SECTION_ASM_OP) \
+  SECTION_FUNCTION_TEMPLATE(rdata_section, in_rdata, RDATA_SECTION_ASM_OP) \
+  SECTION_FUNCTION_TEMPLATE(ctors_section, in_ctors, CTORS_SECTION_ASM_OP) \
+  SECTION_FUNCTION_TEMPLATE(dtors_section, in_dtors, DTORS_SECTION_ASM_OP)
+
+/* This is the pseudo-op used to generate a 32-bit word of data with a
+   specific value in some section.  This is the same for all known svr4
+   assemblers.  */
+
+#define INT_ASM_OP		".long"
+
+/* A C statement (sans semicolon) to output an element in the table of
+   global constructors.  */
+#undef ASM_OUTPUT_CONSTRUCTOR
+#define ASM_OUTPUT_CONSTRUCTOR(FILE,NAME)				\
+  do {									\
+    ctors_section ();							\
+    fprintf (FILE, "\t%s\t ", INT_ASM_OP);				\
+    assemble_name (FILE, NAME);						\
+    fprintf (FILE, "\n");						\
+  } while (0)
+
+/* A C statement (sans semicolon) to output an element in the table of
+   global destructors.  */
+#undef ASM_OUTPUT_DESTRUCTOR
+#define ASM_OUTPUT_DESTRUCTOR(FILE,NAME)       				\
+  do {									\
+    dtors_section ();                   				\
+    fprintf (FILE, "\t%s\t ", INT_ASM_OP);				\
+    assemble_name (FILE, NAME);              				\
+    fprintf (FILE, "\n");						\
+  } while (0)
+
+#define INIT_SECTION_ASM_OP ".section .init,\"x\""
+#define FINI_SECTION_ASM_OP ".section .fini,\"x\""
+
 #undef INVOKE__main
+
 #undef CTOR_LIST_BEGIN
+#define CTOR_LIST_BEGIN                                 \
+asm (CTORS_SECTION_ASM_OP);                             \
+static							\
+func_ptr __CTOR_LIST__[1] = { (func_ptr) (-1) }
+ 
 #undef CTOR_LIST_END
+#define CTOR_LIST_END                                   \
+asm (CTORS_SECTION_ASM_OP);                             \
+static							\
+func_ptr __CTOR_END__[1] = { (func_ptr) 0 };
+ 
 #undef DTOR_LIST_BEGIN
+#define DTOR_LIST_BEGIN                                 \
+asm (DTORS_SECTION_ASM_OP);                             \
+static							\
+func_ptr __DTOR_LIST__[1] = { (func_ptr) (-1) }
+
 #undef DTOR_LIST_END
+#define DTOR_LIST_END                                   \
+asm (DTORS_SECTION_ASM_OP);                             \
+static							\
+func_ptr __DTOR_END__[1] = { (func_ptr) 0 };
+
+
+/* If defined, a C expression whose value is a string containing the
+   assembler operation to identify the following data as
+   uninitialized global data.  If not defined, and neither
+   `ASM_OUTPUT_BSS' nor `ASM_OUTPUT_ALIGNED_BSS' are defined,
+   uninitialized global data will be output in the data section if
+   `-fno-common' is passed, otherwise `ASM_OUTPUT_COMMON' will be
+   used.  */
+#undef BSS_SECTION_ASM_OP
+#define BSS_SECTION_ASM_OP      ".section\t.bss"
+
+#undef SBSS_SECTION_ASM_OP
+#define SBSS_SECTION_ASM_OP     "\t.section .sbss"
+
+/* Like `ASM_OUTPUT_BSS' except takes the required alignment as a
+   separate, explicit argument.  If you define this macro, it is used
+   in place of `ASM_OUTPUT_BSS', and gives you more flexibility in
+   handling the required alignment of the variable.  The alignment is
+   specified as the number of bits.
+
+   Try to use function `asm_output_aligned_bss' defined in file
+   `varasm.c' when defining this macro. */
+
+#undef ASM_OUTPUT_ALIGNED_BSS 
+#define ASM_OUTPUT_ALIGNED_BSS(FILE, DECL, NAME, SIZE, ALIGN) \
+do {									\
+  ASM_GLOBALIZE_LABEL (FILE, NAME);					\
+  if (SIZE > 0 && SIZE <= mips_section_threshold)			\
+    sbss_section ();							\
+  else									\
+    bss_section ();							\
+  ASM_OUTPUT_ALIGN (FILE, floor_log2 (ALIGN / BITS_PER_UNIT));		\
+  last_assemble_variable_decl = DECL;					\
+  ASM_DECLARE_OBJECT_NAME (FILE, NAME, DECL);				\
+  ASM_OUTPUT_SKIP (FILE, SIZE ? SIZE : 1);				\
+} while (0)
+
+/* This says how to output assembler code to declare an
+   uninitialized external linkage data object.  Under SVR4,
+   the linker seems to want the alignment of data objects
+   to depend on their types.  We do exactly that here.  */
+
+#define COMMON_ASM_OP  ".comm"
+
+#define ASM_OUTPUT_ALIGNED_COMMON(FILE, NAME, SIZE, ALIGN)		\
+do {									\
+  fprintf ((FILE), "\t%s\t", COMMON_ASM_OP);				\
+  assemble_name ((FILE), (NAME));					\
+  fprintf ((FILE), ",%u,%u\n", (SIZE), (ALIGN) / BITS_PER_UNIT);	\
+} while (0)
+
+/* This says how to output assembler code to declare an
+   uninitialized internal linkage data object.  Under SVR4,
+   the linker seems to want the alignment of data objects
+   to depend on their types.  We do exactly that here.  */
+
+#define LOCAL_ASM_OP   ".local"
+
+#define ASM_OUTPUT_ALIGNED_LOCAL(FILE, NAME, SIZE, ALIGN)		\
+do {									\
+  fprintf ((FILE), "\t%s\t", LOCAL_ASM_OP);				\
+  assemble_name ((FILE), (NAME));					\
+  fprintf ((FILE), "\n");						\
+  ASM_OUTPUT_ALIGNED_COMMON (FILE, NAME, SIZE, ALIGN);			\
+} while (0)
+
+/* The system header files are C++ aware. */
+#undef NO_IMPLICIT_EXTERN_C
+#define NO_IMPLICIT_EXTERN_C 1
+
+//
+// LIB_SPEC and LINK_SPEC
+//    from gcc-2.7.2 mips patch
+//
+/* Provide a LINK_SPEC appropriate for Linux.  Here we provide support
+   for the special GCC options -static and -shared, which allow us to
+   link things in one of these three modes by applying the appropriate
+   combinations of options at link-time. We like to support here for
+   as many of the other GNU linker options as possible. But I don't
+   have the time to search for those flags. I am sure how to add
+   support for -soname shared_object_name. H.J.
+
+   I took out %{v:%{!V:-V}}. It is too much :-(. They can use
+   -Wl,-V.
+
+   When the -shared link option is used a final link is not being
+   done.  */
+
+#undef LINK_SPEC
+#define LINK_SPEC "\
+%{G*} %{EB} %{EL} %{mips1} %{mips2} %{mips3} %{mips4} \
+%{bestGnum} %{shared} %{non_shared} \
+%{call_shared} %{no_archive} %{exact_version} \
+  %{!shared: \
+      %{!static: \
+       %{rdynamic:-export-dynamic} \
+       %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
+      %{static:-static}}"
+
+
+/*
+ * Notes on LIB_SPEC 
+ *
+ * Both -p and -pg will produce function profiling codes.
+ * Difference of thease is only wheather linking 
+ * static profiled libc or not.
+ *
+ *	gcc -p 		->	... -lgcc -lc_p -lgcc
+ *	gcc -pg		->	... -lgcc -lc -lgcc
+ *
+ */
+
+#undef LIB_SPEC
+#define LIB_SPEC \
+  "%{!shared: %{mieee-fp:-lieee} \
+	%{a: %{!ggdb:-lc} %{ggdb:-lg}} \
+  	%{!a: %{p:-lc_p}  \
+		%{!p: %{!ggdb:-lc} %{ggdb:-lg} } } }"
+
+
+//
+// linux/include/asm-mips/posix_types.h use pre-defined size macro
+//
+//
+
+#undef SUBTARGET_CPP_SIZE_SPEC 
+#define SUBTARGET_CPP_SIZE_SPEC "\
+%{mgp64: -D_MIPS_SZPTR=64 } \
+%{!mgp64: -D_MIPS_SZPTR=32 } \
+\
+%{mlong64:-D__SIZE_TYPE__=long\\ unsigned\\ int \
+  -D__SSIZE_TYPE__=long\\ int \
+  -D__PTRDIFF_TYPE__=long\\ int \
+  -D_MIPS_SZLONG=64}  \
+\
+%{mint64:-D_MIPS_SZINT=64 \
+  %{!mlong64:-D__SIZE_TYPE__=long\\ unsigned\\ int \
+    -D__SSIZE_TYPE__=long\\ int \
+    -D__PTRDIFF_TYPE__=long\\ int \
+    -D_MIPS_SZLONG=64}} \
+\
+%{!mint64:-D_MIPS_SZINT=32 \
+  %{!mlong64:-D__SIZE_TYPE__=unsigned\\ int \
+    -D__SSIZE_TYPE__=int \
+    -D__PTRDIFF_TYPE__=int \
+    -D_MIPS_SZLONG=32}} \
+" \
+
+/* assume "-mips1 & -fPIC " is default */
+#undef SUBTARGET_CPP_SPEC 
+#define SUBTARGET_CPP_SPEC "\
+%{mfp32: -D_MIPS_FPSET=16}%{!mfp32: -D_MIPS_FPSET=32} \
+%{mips1: -D_MIPS_ISA=_MIPS_ISA_MIPS1} \
+%{mips2: -D_MIPS_ISA=_MIPS_ISA_MIPS2} \
+%{mips3: -D_MIPS_ISA=_MIPS_ISA_MIPS3} \
+%{mips4: -D_MIPS_ISA=_MIPS_ISA_MIPS4} \
+%{!mips*: -D_MIPS_ISA=_MIPS_ISA_MIPS1} \
+%{fno-PIC: -U__PIC__ -U__pic__} \
+%{fno-pic: -U__PIC__ -U__pic__} \
+%{fPIC: -D__PIC__ -D__pic__} \
+%{fpic: -D__PIC__ -D__pic__} \
+%{!fpic: %{!fPIC: %{!fno-pic: %{!fno-pic: -D__PIC__ -D__pic__}}}} \
+%{-D__HAVE_FPU__ } \
+%{posix: -D_POSIX_SOURCE} \
+%{.cc:	-D__LANGUAGE_C_PLUS_PLUS__  %{!ansi:-DLANGUAGE_C_PLUS_PLUS}} \
+%{.cxx:	-D__LANGUAGE_C_PLUS_PLUS__  %{!ansi:-DLANGUAGE_C_PLUS_PLUS}} \
+%{.C:	-D__LANGUAGE_C_PLUS_PLUS__  %{!ansi:-DLANGUAGE_C_PLUS_PLUS}} \
+%{.m:	-D__LANGUAGE_OBJECTIVE_C__ %{!ansi:-DLANGUAGE_OBJECTIVE_C}} \
+%{.S:	-D__LANGUAGE_ASSEMBLY__ %{!ansi:-DLANGUAGE_ASSEMBLY}} \
+%{.s:	-D__LANGUAGE_ASSEMBLY__ %{!ansi:-DLANGUAGE_ASSEMBLY}} \
+%{!.S: %{!.s: %{!.cc: %{!.cxx: %{!.C: %{!.m: -D__LANGUAGE_C__ %{!ansi:-DLANGUAGE_C}}}}}} } \
+%{ansi: -Uunix -Ulinux -Umips -UR3000 -UMIPSEB -UMIPSEL} \
+ "
+
+
+// assume
+// 	TARGET_DEFAULT includes MASK_ABICALLS|GAS_MASK
+// if MASK_ABICALLS is given , pic-flag is also on.
+
+#undef SUBTARGET_ASM_SPEC
+#define SUBTARGET_ASM_SPEC "\
+%{fno-pic: -non_shared} \
+%{mno-abicalls: -non_shared} \
+%{!fno-pic: %{!mno-abicalls: -KPIC}} \
+ "
+
+#undef SUBTARGET_CC1_SPEC 
+#define SUBTARGET_CC1_SPEC "\
+%{fno-pic: -mno-abicalls} \
+ "
+
+
+#if (TARGET_ENDIAN_DEFAULT == 0)
+
+// default is  elf, -mabi=o32, -mips1 and -EL
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "\
+-D__ELF__ -D_MIPS_SIM=_MIPS_SIM_ABI32 \
+-Dunix  -D__unix__ \
+-Dlinux -D__linux__ \
+-Dmips -D_mips -D__mips -D__mips__ \
+-DR3000 -D_R3000 \
+-DMIPSEL -D_MIPSEL -D__MIPSEL -D__MIPSEL__ \
+-Asystem=linux -Asystem=posix -Acpu=mips -Amachine=mips \
+ "
+
+
+#else
+// default is  elf, -mabi=o32, -mips1 and -EB
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "\
+-D__ELF__ -D_MIPS_SIM=_MIPS_SIM_ABI32 \
+-Dunix  -D__unix__ \
+-Dlinux -D__linux__ \
+-Dmips -D_mips -D__mips -D__mips__ \
+-DR3000 -D_R3000 \
+-DMIPSEB -D_MIPSEB -D__MIPSEB -D__MIPSEB__ \
+-Asystem=linux -Asystem=posix -Acpu=mips -Amachine=mips \
+ "
+
+#endif
+
 
 /* The MIPS assembler has different syntax for .set. We set it to
    .dummy to trap any errors.  */
@@ -189,9 +516,6 @@
     fprintf (FILE, "%sLM%d:\n\t%s 68,0,%d,%sLM%d",			\
 	     LOCAL_LABEL_PREFIX, sym_lineno, ASM_STABN_OP,		\
 	     LINE, LOCAL_LABEL_PREFIX, sym_lineno);			\
-    putc ('-', FILE);							\
-    assemble_name (FILE,						\
-		   XSTR (XEXP (DECL_RTL (current_function_decl), 0), 0));\
     putc ('\n', FILE);							\
     sym_lineno++;							\
   }									\
@@ -253,7 +577,15 @@
    pseudo-ops.  */
 #define FUNCTION_NAME_ALREADY_DECLARED
 
+#define IDENT_ASM_OP ".ident"
+
 /* Output #ident as a .ident.  */
 #undef ASM_OUTPUT_IDENT
 #define ASM_OUTPUT_IDENT(FILE, NAME) \
   fprintf (FILE, "\t%s\t\"%s\"\n", IDENT_ASM_OP, NAME);
+
+/* produce compressed bbtrace */
+#ifndef HAVE_POPEN
+#define HAVE_POPEN
+#endif
+
diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/mips-bb-helper.asm gcc-3.0.4-eelinux/gcc/config/mips/mips-bb-helper.asm
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/mips-bb-helper.asm	Wed Dec 31 18:00:00 1969
+++ gcc-3.0.4-eelinux/gcc/config/mips/mips-bb-helper.asm	Thu Mar  7 03:47:25 2002
@@ -0,0 +1,242 @@
+/* Copyright (C) 2001  Sony Computer Entertainment Inc. */
+/* Copyright 2001  Sony Corportaion. */
+
+/* This file is subject to the terms and conditions of the GNU General 
+   Public License version 2. See the file "COPYING" in the main directory 
+   of this archive for more details.  */
+
+/* As a special exception, if you link this library with other files,
+   some of which are compiled with GCC, to produce an executable,
+   this library does not by itself cause the resulting executable
+   to be covered by the GNU General Public License.
+   This exception does not however invalidate any other reasons why
+   the executable file might be covered by the GNU General Public License.  */
+
+
+
+/*
+ * BLOCK PROFILER helper functions
+ *
+ */
+	.text
+	.set noat
+
+ 	REG_SIZE = 4
+	OFF_A0 = REG_SIZE * 7
+	OFF_A1 = REG_SIZE * 8
+	OFF_A2 = REG_SIZE * 9
+	OFF_A3 = REG_SIZE * 10
+	OFF_AT = REG_SIZE * 11
+	OFF_V0 = REG_SIZE * 12
+	OFF_V1 = REG_SIZE * 13
+	OFF_FP = REG_SIZE * 14
+	OFF_T0 = REG_SIZE * 15
+	OFF_T1 = REG_SIZE * 16
+	OFF_T2 = REG_SIZE * 17
+	OFF_T3 = REG_SIZE * 18
+	OFF_T4 = REG_SIZE * 19
+	OFF_T5 = REG_SIZE * 20
+	OFF_T6 = REG_SIZE * 21
+	OFF_T7 = REG_SIZE * 22
+	OFF_T8 = REG_SIZE * 23
+
+	OFF_HI = REG_SIZE * 24
+	OFF_LO = REG_SIZE * 25
+	
+/*
+ *
+ */
+
+	  .align	2;
+	  .globl	__bb_mips_save_regs_sw
+	  .ent  	__bb_mips_save_regs_sw
+__bb_mips_save_regs_sw:
+
+	/*"$28"	/*gp: 4*/
+	/*"$31"	/*ra: 5*/
+	/*"$25"	/*t9: 6*/
+
+	sw	$4,  OFF_A0($29)	/*a0: 7*/ 
+	sw	$5,  OFF_A1($29)	/*a1: 8*/ 
+	sw	$6,  OFF_A2($29)	/*a2: 9*/ 
+	sw	$7,  OFF_A3($29)	/*a3: 10*/ 
+	sw	$1,  OFF_AT($29)	/*at: 11*/
+	sw	$2,  OFF_V0($29)	/*v0: 12*/ 
+	sw	$3,  OFF_V1($29)	/*v1: 13*/
+	sw	$30, OFF_FP($29)	/*fp: 14*/
+	sw	$8,  OFF_T0($29)	/*t0: 15*/
+	sw	$9,  OFF_T1($29)	/*t1: 16*/
+	sw	$10, OFF_T2($29)	/*t2: 17*/
+	sw	$11, OFF_T3($29)	/*t3: 18*/
+	sw	$12, OFF_T4($29)	/*t4: 19*/
+	sw	$13, OFF_T5($29)	/*t5: 20*/
+	sw	$14, OFF_T6($29)	/*t6: 21*/
+	sw	$15, OFF_T7($29)	/*t7: 22*/
+	sw	$24, OFF_T8($29)	/*t8: 23*/
+	
+
+	mfhi	$4
+	sw	$4,  OFF_HI($29)	/*hi: 24*/
+	mflo	$4
+	sw	$4,  OFF_LO($29)	/*lo: 25*/
+	j	$31
+	nop
+	.size	__bb_mips_save_regs_sw, .- __bb_mips_save_regs_sw;
+	.end	__bb_mips_save_regs_sw
+
+
+/*
+ *
+ */
+
+	.align	2
+	.globl	__bb_mips_restore_regs_lw
+	.ent	__bb_mips_restore_regs_lw
+__bb_mips_restore_regs_lw:
+
+	lw	$4,  OFF_HI($29)	/*hi: 25*/
+	mthi	$4
+	lw	$4,  OFF_LO($29)	/*lo: 26*/
+	mtlo	$4
+
+	lw	$4,  OFF_A0($29)	/*a0: 7*/ 
+	lw	$5,  OFF_A1($29)	/*a1: 8*/ 
+	lw	$6,  OFF_A2($29)	/*a2: 9*/ 
+	lw	$7,  OFF_A3($29)	/*a3: 10*/ 
+	lw	$1,  OFF_AT($29)	/*at: 11*/
+	lw	$2,  OFF_V0($29)	/*v0: 12*/ 
+	lw	$3,  OFF_V1($29)	/*v1: 13*/
+	lw	$30, OFF_FP($29)	/*fp: 14*/
+	lw	$8,  OFF_T0($29)	/*t0: 15*/
+	lw	$9,  OFF_T1($29)	/*t1: 16*/
+	lw	$10, OFF_T2($29)	/*t2: 17*/
+	lw	$11, OFF_T3($29)	/*t3: 18*/
+	lw	$12, OFF_T4($29)	/*t4: 19*/
+	lw	$13, OFF_T5($29)	/*t5: 20*/
+	lw	$14, OFF_T6($29)	/*t6: 21*/
+	lw	$15, OFF_T7($29)	/*t7: 22*/
+	lw	$24, OFF_T8($29)	/*t8: 23*/
+	
+	
+	j	$31
+	nop
+	/*"$28"	/*gp: 4*/
+	/*"$31"	/*ra: 5*/
+	/*"$25"	/*t9: 6*/
+	.size	__bb_mips_restore_regs_lw, .- __bb_mips_restore_regs_lw;
+	.end	__bb_mips_restore_regs_lw
+
+
+
+/*
+ *
+ */
+ 	REG_SIZE = 8
+	OFF_A0 = REG_SIZE * 7
+	OFF_A1 = REG_SIZE * 8
+	OFF_A2 = REG_SIZE * 9
+	OFF_A3 = REG_SIZE * 10
+	OFF_AT = REG_SIZE * 11
+	OFF_V0 = REG_SIZE * 12
+	OFF_V1 = REG_SIZE * 13
+	OFF_FP = REG_SIZE * 14
+	OFF_T0 = REG_SIZE * 15
+	OFF_T1 = REG_SIZE * 16
+	OFF_T2 = REG_SIZE * 17
+	OFF_T3 = REG_SIZE * 18
+	OFF_T4 = REG_SIZE * 19
+	OFF_T5 = REG_SIZE * 20
+	OFF_T6 = REG_SIZE * 21
+	OFF_T7 = REG_SIZE * 22
+	OFF_T8 = REG_SIZE * 23
+
+	OFF_HI = REG_SIZE * 24
+	OFF_LO = REG_SIZE * 25
+	
+
+	mfhi	$4
+	sd	$4,  OFF_HI($29)	/*hi: 24*/
+	mflo	$4
+	sd	$4,  OFF_LO($29)	/*lo: 25*/
+	  .align	2;
+	  .globl	__bb_mips_save_regs_sd
+	  .ent  	__bb_mips_save_regs_sd
+__bb_mips_save_regs_sd:
+	.set	push
+	.set	mips3
+	/*"$28"	/*gp: 4*/
+	/*"$31"	/*ra: 5*/
+	/*"$25"	/*t9: 6*/
+
+	sd	$4,  OFF_A0($29)	/*a0: 7*/ 
+	sd	$5,  OFF_A1($29)	/*a1: 8*/ 
+	sd	$6,  OFF_A2($29)	/*a2: 9*/ 
+	sd	$7,  OFF_A3($29)	/*a3: 10*/ 
+	sd	$1,  OFF_AT($29)	/*at: 11*/
+	sd	$2,  OFF_V0($29)	/*v0: 12*/ 
+	sd	$3,  OFF_V1($29)	/*v1: 13*/
+	sd	$30, OFF_FP($29)	/*fp: 14*/
+	sd	$8,  OFF_T0($29)	/*t0: 15*/
+	sd	$9,  OFF_T1($29)	/*t1: 16*/
+	sd	$10, OFF_T2($29)	/*t2: 17*/
+	sd	$11, OFF_T3($29)	/*t3: 18*/
+	sd	$12, OFF_T4($29)	/*t4: 19*/
+	sd	$13, OFF_T5($29)	/*t5: 20*/
+	sd	$14, OFF_T6($29)	/*t6: 21*/
+	sd	$15, OFF_T7($29)	/*t7: 22*/
+	sd	$24, OFF_T8($29)	/*t8: 23*/
+	
+
+	mfhi	$4
+	sd	$4,  OFF_HI($29)	/*hi: 24*/
+	mflo	$4
+	sd	$4,  OFF_LO($29)	/*lo: 25*/
+	j	$31
+	nop
+	.set	pop
+	.size	__bb_mips_save_regs_sd, .- __bb_mips_save_regs_sd;
+	.end	__bb_mips_save_regs_sd
+
+
+
+/*
+ *
+ */
+	.align	2
+	.globl	__bb_mips_restore_regs_ld
+	.ent	__bb_mips_restore_regs_ld
+__bb_mips_restore_regs_ld:
+	.set	push
+	.set	mips3
+
+
+	ld	$4,  OFF_HI($29)	/*hi: 25*/
+	mthi	$4
+	ld	$4,  OFF_LO($29)	/*lo: 26*/
+	mtlo	$4
+
+	ld	$4,  OFF_A0($29)	/*a0: 7*/ 
+	ld	$5,  OFF_A1($29)	/*a1: 8*/ 
+	ld	$6,  OFF_A2($29)	/*a2: 9*/ 
+	ld	$7,  OFF_A3($29)	/*a3: 10*/ 
+	ld	$1,  OFF_AT($29)	/*at: 11*/
+	ld	$2,  OFF_V0($29)	/*v0: 12*/ 
+	ld	$3,  OFF_V1($29)	/*v1: 13*/
+	ld	$30, OFF_FP($29)	/*fp: 14*/
+	ld	$8,  OFF_T0($29)	/*t0: 15*/
+	ld	$9,  OFF_T1($29)	/*t1: 16*/
+	ld	$10, OFF_T2($29)	/*t2: 17*/
+	ld	$11, OFF_T3($29)	/*t3: 18*/
+	ld	$12, OFF_T4($29)	/*t4: 19*/
+	ld	$13, OFF_T5($29)	/*t5: 20*/
+	ld	$14, OFF_T6($29)	/*t6: 21*/
+	ld	$15, OFF_T7($29)	/*t7: 22*/
+	ld	$24, OFF_T8($29)	/*t8: 23*/
+	
+	
+	j	$31
+	nop
+	.set	pop
+	.size	__bb_mips_restore_regs_ld, .- __bb_mips_restore_regs_ld;
+	.end	__bb_mips_restore_regs_ld
+
